#include<bits/stdc++.h>
using namespace std;
int c,T;
int n,k,x,y;
struct nd{
	int from,to,nxt;
}li[200002];
int ptr,ind[100002];
vector<int> bg;
void add(int x,int y)
{
	li[++ptr]=((nd){x,y,ind[x]});
	ind[x]=ptr;
}
int ans;
bool vis[200002];
void dfs(int x,int cnt,int fa)
{
//	cout<<x<<" ";
	if(cnt==n-1)
	{
		ans++;
//		cout<<endl;
		return ;
	}
	for(int i=ind[li[x].from];i!=-1;i=li[i].nxt)
	{
		if(li[i].to!=fa&&li[i].from!=x&&!vis[i])
		{
			vis[i]=true;
			dfs(li[i].to,cnt+1,x);
			vis[i]=false;
		}
	}
	for(int j=ind[li[x].to];j!=-1;j=li[j].nxt)
	{
		if(li[j].to!=fa&&li[j].from!=x&&!vis[j])
		{
			vis[j]=true;
			dfs(li[j].to,cnt+1,x);
			vis[j]=false;
		}
	}
}
int main()
{
	freopen("traverse.in","r",stdin);
	freopen("traverse.out","w",stdout);
	cin>>c>>T;
	memset(ind,-1,sizeof(ind));
	while(T--)
	{
		for(int i=1;i<=n;i++)
		{
			ind[i]=-1;
			li[2*i-1]=((nd){0,0});
			li[2*i]=((nd){0,0});
			vis[2*i-1]=vis[2*i]=false;
		}
		scanf("%d %d",&n,&k);
		for(int i=1;i<n;i++)
		{
			scanf("%d %d",&x,&y);
			add(x,y);
			add(y,x);	
		}
		for(int i=1;i<=k;i++)
		{
			scanf("%d",&x);
			bg.push_back(x);
		}
		if(k<=1)
		{
			dfs(2*x-1,1,0);
			printf("%d\n",ans/2);
		}
	}
	return 0;
}
/*
1 1
4 1
1 2
2 3
2 4
1

7 1
5 1
1 2
1 3
2 4
2 5
1 
*/
